Package edu.msu.cme.rdp.classifier.train.validation

# Class NBClassifier

java.lang.Object
edu.msu.cme.rdp.classifier.train.validation.NBClassifier

public class NBClassifier extends Object

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`MIN_BOOTSTRSP_WORDS`
`static final long`
`seed`

## Constructor Summary

Constructors
Constructor
Description
`NBClassifier(TreeFactory f, int[] wordList, ArrayList<HierarchyTree> nodes, boolean useSeed, int min_bootstrap_words)`

## Method Summary

Modifier and Type
Method
Description
`ValidationClassificationResult`
`assignClass()`
for a array of subclasses, gets the probabilities of each subclass, returns the classification whose subclass has the highest probability.
`ValidationClassificationResult`
`assignClassRandomsample()`
This method random select certain number of words and calculate the probability This can only be called after the assignClass() filled the querySeq_wordProbArr matrix

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### MIN_BOOTSTRSP_WORDS

public static final int MIN_BOOTSTRSP_WORDS

See Also:
  - Constant Field Values

### seed

public static final long seed

See Also:
  - Constant Field Values

## Constructor Details

### NBClassifier

public NBClassifier(TreeFactory f, int[] wordList, ArrayList<HierarchyTree> nodes, boolean useSeed, int min_bootstrap_words) throws IOException

Throws:
  `IOException`

## Method Details

### assignClass

public ValidationClassificationResult assignClass()
for a array of subclasses, gets the probabilities of each subclass, returns the classification whose subclass has the highest probability. formula: prob = sum( log(p (wi|c) ) ) i = 1 to n for n words denominator = log ( sum( exp (prob)j ) ) for j = 1 to m for m classes final log posterior prob = prob + p(c) - denominator

### assignClassRandomsample

public ValidationClassificationResult assignClassRandomsample()
This method random select certain number of words and calculate the probability This can only be called after the assignClass() filled the querySeq_wordProbArr matrix

Returns:
  the classification whose subclass has the highest probability.